"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PactVerifierService = void 0;
const common_1 = require("@nestjs/common");
const get_port_1 = __importDefault(require("get-port"));
const pact_1 = require("@pact-foundation/pact");
const pact_module_providers_enum_1 = require("../common/pact-module-providers.enum");
let PactVerifierService = class PactVerifierService {
    constructor(options) {
        this.options = options;
    }
    async verify(app) {
        const host = new URL(this.options.providerHost || 'http://localhost');
        await app.listen(host.port || (await (0, get_port_1.default)()), host.hostname);
        return new pact_1.Verifier(Object.assign(Object.assign({}, this.options), { providerBaseUrl: await app.getUrl() }))
            .verifyProvider()
            .finally(() => app.close());
    }
};
PactVerifierService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(pact_module_providers_enum_1.PactModuleProviders.ProviderOptions)),
    __metadata("design:paramtypes", [Object])
], PactVerifierService);
exports.PactVerifierService = PactVerifierService;
//# sourceMappingURL=pact-verifier.service.js.map